<?php

// Require json support
include_once('wfmjson.php');

// Only define the function if it doesn't already exist
if (!function_exists('wpember')) {

	function wpember($username = '', $collection = '') {
		// Construct the url
		$url = 'http://api.emberapp.com/users/view/'.urlencode($username).'/collections/view/'.urlencode($collection).'/';
		
		// We are going to use curl to grab the url
		$ch = curl_init();
		$timeout = 5;
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
		$data = curl_exec($ch);
		curl_close($ch);

		// Generate the hash
		$ember = array();

		// Query the data for all image elements
		$xml = new SimpleXMLElement($data);
		$images = $xml->xpath('images/image');

		// Loop over each image
		foreach ($images as $image) {
			$file = $image->xpath('file');
			$file = $file[0];

			$desc = $image->xpath('description');
			$desc = $desc[0];

			$src = $file->xpath('src');
			$src = $src[0];

			$ember[(string)$src] = array('caption' => (string)$desc, 'thumbnail' => (string)$src, 'href' => (string)$src);
			//error_log('src: '.$src.' caption: '.$desc.' thumbnail: '.$src.' href: '.$href);
		}
		
		// Return a json encoded string
		return json_encode($ember);
	}
}
?>